// -*- C++ -*-
/*
#
# This Program is part of Dictionary Reader
# Copyright (C) 2001 Takashi Nemoto
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details. 
#
#    Send bugs and comments to tnemoto@mvi.biglobe.ne.jp
#
*/

#include <string>
#include <vector>

xmlNodePtr XML_CreateNodesFromXPath(xmlDocPtr doc,const std::string& path);
xmlNodePtr XML_GetNodeFromXPath(xmlDocPtr doc,const std::string& path);
std::vector<xmlNodePtr> XML_GetNodesFromXPath(xmlDocPtr doc,
					 const std::string& path);
bool XML_SetString(xmlDocPtr doc,xmlNodePtr np,const std::string& str);
bool XML_Match(xmlNodePtr node,char* str2);
std::string XML_GetString(xmlDocPtr doc,xmlNodePtr node);
int XML_GetInt(xmlDocPtr doc,xmlNodePtr node);
bool XML_GetBool(xmlDocPtr doc,xmlNodePtr node);
const xmlChar* XML_IntString(char* buf,int len, int num);
const xmlChar* XML_BoolString(bool b);
